import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 18.12.2011
  * @author
  */

public class Strasse extends JFrame {
  // Anfang Attribute
  private Panel panel1 = new Panel(null);
    private Button button1 = new Button();
    private Button button2 = new Button();
  private Turtle t = new Turtle(100, 100);
  // Ende Attribute

  public Strasse(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 303; 
    int frameHeight = 306;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(true);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    panel1.setBounds(0, 0, 305, 41);
    panel1.setBackground(new Color(0xC0C0C0));
    panel1.addHierarchyBoundsListener(new HierarchyBoundsAdapter() { 
      public void ancestorResized(HierarchyEvent evt) { 
        panel1_AncestorResized(evt);
      }
    });
    cp.add(panel1);
    button1.setBounds(8, 8, 97, 25);
    button1.setLabel("Zeichnen");
    button1.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        button1_ActionPerformed(evt);
      }
    });
    panel1.add(button1);
    t.setBounds(0, 40, 305, 241);
    t.setBackground(Color.WHITE);
    t.addHierarchyBoundsListener(new HierarchyBoundsAdapter() { 
      public void ancestorResized(HierarchyEvent evt) { 
        t_AncestorResized(evt);
      }
    });
    cp.add(t);
    button2.setBounds(120, 8, 89, 25);
    button2.setLabel("Lschen");
    button2.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        button2_ActionPerformed(evt);
      }
    });
    panel1.add(button2);
    t.setBounds(304, 40, 60, 84);
    setTitle("Turtle-Intro");
    // Ende Komponenten

    setVisible(true);
  }

  // Anfang Methoden
  public void zeichneRechteck(double breit, double hoch) {
     int i = 0;
     while (i < 2) {
       t.draw(breit);
       t.turn(90);
       t.draw(hoch);
       t.turn(90);
       i = i + 1;
     }
  }
  
  public void zeichneHaus(double breite, double hoehe) {
     double b5 = breite/5;
     double h7 = hoehe/7;
     zeichneRechteck(breite, hoehe);
     t.move(b5);
     zeichneRechteck(b5, 2*h7);
     t.turn(90);
     t.move(3*h7);
     t.turn(-90);
     zeichneRechteck(b5, h7);
     t.turn(90);
     t.move(2*h7);
     t.turn(-90);
     zeichneRechteck(b5, h7);
     
     t.move(2*b5);
     zeichneRechteck(b5, h7);
     t.turn(-90);
     t.move(2*h7);
     t.turn(90);
     zeichneRechteck(b5, h7);
     t.turn(-90);
     t.move(2*h7);
     t.turn(90);
     zeichneRechteck(b5, h7);

     t.move(-3*b5);
     t.turn(90);
     t.move(6*h7);
     t.turn(-45);
     t.draw(breite/Math.sqrt(2));
     t.turn(-90);
     t.draw(breite/Math.sqrt(2));
     t.turn(-45);
     
     t.move(hoehe);
     t.turn(90);
  }
  
  public void button1_ActionPerformed(ActionEvent evt) {
     t.moveto(20, t.getHeight()- 60);
     double b = 30 + 50 * Math.random();
     double h = b + 3*b * Math.random();
     while (t.turtleX + b < getWidth()) {
         zeichneHaus(b, h);
         b = 50 + 150 * Math.random();
         h = b + 3*b * Math.random();
     }
  }

  public void button2_ActionPerformed(ActionEvent evt) {
    t.clear();
  }
  
  public void panel1_AncestorResized(HierarchyEvent evt) {
    panel1.setBounds(0, 0, getWidth(), 50);
  }
  
  public void t_AncestorResized(HierarchyEvent evt) {
    t.setBounds(0, 50, getWidth(), getHeight() - 50);
  }

  // Ende Methoden
  
  public static void main(String[] args) {
    new Strasse("Strasse");
  }
  
}